//------------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//------------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//------------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Load dynamic link library---pstopdf.dll
//------------------------------------------------------------------------------
BOOL TForm1::LoadDLL()
{
	nHandle=LoadLibrary("pstopdf.dll");
	if( nHandle == NULL )
		goto Failer;

	oakBegin=(poakBegin)GetProcAddress(nHandle,"_oakBegin@0");
	if( oakBegin == NULL ) goto Failer;

	oakEnd=(poakEnd)GetProcAddress(nHandle,"_oakEnd@4");
	if( oakEnd == NULL ) goto Failer;

	oakExport = (poakExport)GetProcAddress(nHandle,"_oakExport@4");
	if( oakExport == NULL ) goto Failer;

	oakSetOption=(poakSetOption)GetProcAddress(nHandle,"_oakSetOption@24");
	if( oakSetOption == NULL ) goto Failer;

	oakGetOption=(poakGetOption)GetProcAddress(nHandle,"_oakGetOption@24");
	if( oakGetOption == NULL ) goto Failer;

	return TRUE;

Failer:
	FreeDLL(); 
	return FALSE;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Free dynamic link library---pstopdf.dll
//------------------------------------------------------------------------------
void TForm1::FreeDLL()
{
	if( nHandle == NULL )
		return;

	FreeLibrary(nHandle);
	nHandle = NULL;	
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Convert one ps/eps file to a general pdf file.
//------------------------------------------------------------------------------
void __fastcall TForm1::btnDemo1Click(TObject *Sender)
{
	long id, iRet;
    
	//Load dynamic link library---pstotiff.dll
	if( !LoadDLL() ){
		MessageBox(NULL, "Loading dynamic link library---pstopdf.dll failure!", "OakDoc PS to PDF Demo", MB_OK);
		return;
	}

    id = oakBegin();
	oakSetOption(id, OAK_Set_Input, 0, 0, "_test_01.ps", NULL);
    oakSetOption(id, OAK_Set_Input, 0, 0, "_test_02.eps", NULL);
	oakSetOption(id, OAK_Set_Output, 0, 0, "mytest_general.pdf", NULL);

    oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_TITLE, "untitled document");
    oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_AUTHOR, "bobol");
    oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_APPLICATION, "OakDoc PS to PDF sdk demo");

	iRet = oakExport(id);
	oakEnd(id);

	//Free dynamic link library---pstopdf.dll
	FreeDLL();
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Convert one ps/eps file to an restricted pdf file.
//------------------------------------------------------------------------------
void __fastcall TForm1::btnDemo2Click(TObject *Sender)
{
	long id, iRet;
    char sOwnerPw[] = "1111";
    char sUserPw[]  = "2222";
    
	//Load dynamic link library---pstotiff.dll
	if( !LoadDLL() ){
		MessageBox(NULL, "Loading dynamic link library---pstopdf.dll failure!", "OakDoc PS to PDF Demo", MB_OK);
		return;
	}

    id = oakBegin();
	oakSetOption(id, OAK_Set_Input, 0, 0, "_test_01.ps", NULL);
    oakSetOption(id, OAK_Set_Input, 0, 0, "_test_02.eps", NULL);
	oakSetOption(id, OAK_Set_Output, 0, 0, "mytest_restricted.pdf", NULL);

    oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_TITLE, "untitled document");
    oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_AUTHOR, "bobol");
    oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_APPLICATION, "OakDoc PS to PDF sdk demo");

    oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_128, OAK_PDF_PERMISSION_PRINT+OAK_PDF_PERMISSION_COPYING, sUserPw, sOwnerPw);
    
	iRet = oakExport(id);
	oakEnd(id);

	//Free dynamic link library---pstopdf.dll
	FreeDLL();
}
//------------------------------------------------------------------------------

