unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, oakexport;

type
  TForm1 = class(TForm)
    btnDemo1: TButton;
    btnDemo2: TButton;
    procedure btnDemo1Click(Sender: TObject);
    procedure btnDemo2Click(Sender: TObject);
  private
    { Private declarations }
    //SDK interface definitions.
    //For more,please refer to "oakexport.pas"
    //---------------------------------------------------------------------------
    hDLL: HMODULE;
    oakBegin: FoakBegin;
    oakEnd: FoakEnd;
    oakExport: FoakExport;
    oakSetOption: FoakSetOption;
    oakGetOption: FoakGetOption;

    function LoadDLL(): BOOL;  //Load dynamic link library "pstopdf.dll"
    function FreeDLL(): BOOL;  //free dynamic link library "pstopdf.dll"
    //----------------------------------------------------------------------------

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//------------------------------------------------------------------------------------------------------
// Load dynamic link library---pstopdf.dll
//------------------------------------------------------------------------------------------------------
function TForm1.LoadDLL(): BOOL;
var
   pFunc: FARPROC;
label
   ERR_FLAG;
begin
   hDLL := LoadLibrary('pstopdf.dll');
   if hDLL = 0 then
   begin
      Result := FALSE;
      exit;
   end;

	 pFunc := GetProcAddress(hDLL, '_oakBegin@0');
	 if pFunc = nil then goto ERR_FLAG;
   oakBegin := pFunc;

	 pFunc := GetProcAddress(hDLL, '_oakEnd@4');
	 if pFunc = nil then goto ERR_FLAG;
   oakEnd := pFunc;

	 pFunc := GetProcAddress(hDLL, '_oakExport@4');
	 if pFunc = nil then goto ERR_FLAG;
   oakExport := pFunc;

	 pFunc := GetProcAddress(hDLL, '_oakSetOption@24');
	 if pFunc = nil then goto ERR_FLAG;
   oakSetOption := pFunc;

	 pFunc := GetProcAddress(hDLL, '_oakGetOption@24');
	 if pFunc = nil then goto ERR_FLAG;
   oakGetOption := pFunc;

   Result := TRUE;
   exit;

ERR_FLAG:
   Result := FALSE;
end;

//------------------------------------------------------------------------------------------------------
// Free dynamic link library---pstopdf.dll
//------------------------------------------------------------------------------------------------------
function TForm1.FreeDLL(): BOOL;
begin
   if hDLL <> 0  then
   begin
      FreeLibrary(hDLL);
      hDLL := 0;
   end;
   Result := TRUE;
end;

//------------------------------------------------------------------------------------------------
// Convert one ps/eps file to a general pdf file.
//------------------------------------------------------------------------------------------------
procedure TForm1.btnDemo1Click(Sender: TObject);
var
	 id, iRet: Longint;
begin
   if LoadDLL() = FALSE then exit;

   id := oakBegin();
   oakSetOption(id, OAK_Set_Input, 0, 0, '_test_01.ps', nil); //input file.
   oakSetOption(id, OAK_Set_Input, 0, 0, '_test_02.eps', nil); //input file.
   oakSetOption(id, OAK_Set_Output, 0, 0, 'mytest_general.pdf', nil); //output pdf file.

   oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_TITLE, 'untitled document');
   oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_AUTHOR, 'bobol');
   oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_APPLICATION, 'OakDoc PS to PDF sdk demo');
   
   iRet := oakExport(id);
   oakEnd(id);
   
   FreeDLL();
end;

//------------------------------------------------------------------------------------------------
// Convert one ps/eps file to an restricted pdf file.
//------------------------------------------------------------------------------------------------
procedure TForm1.btnDemo2Click(Sender: TObject);
var
	 id, iRet: Longint;
   sUserPw, sOwnerPw: PChar;
begin
   sOwnerPw := '1111';
   sUserPw  := '2222';

   if LoadDLL() = FALSE then exit;

   id := oakBegin();
   oakSetOption(id, OAK_Set_Input, 0, 0, '_test_01.ps', nil); //input file.
   oakSetOption(id, OAK_Set_Input, 0, 0, '_test_02.eps', nil); //input file.
   oakSetOption(id, OAK_Set_Output, 0, 0, 'mytest_restricted.pdf', nil); //output format and file.

   oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_TITLE, 'untitled document');
   oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_AUTHOR, 'bobol');
   oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_APPLICATION, 'OakDoc PS to PDF sdk demo');

   oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_128, OAK_PDF_PERMISSION_PRINT+OAK_PDF_PERMISSION_COPYING, sUserPw, sOwnerPw);

   iRet := oakExport(id);
   oakEnd(id);
   
   FreeDLL();
end;

end.


