#include <Windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "oakexport.h"

HMODULE    nHandle=NULL;
poakBegin  oakBegin;
poakEnd    oakEnd;
poakExport oakExport;
poakSetOption oakSetOption;
poakGetOption oakGetOption;

BOOL LoadDLL();
void FreeDLL();


/*------------------------------------------------------------------------------------------------------
 Load dynamic link library---pstopdf.dll
------------------------------------------------------------------------------------------------------*/
BOOL LoadDLL()
{
	nHandle=LoadLibrary("pstopdf.dll");
	if( nHandle == NULL )
		goto Failer;

	oakBegin=(poakBegin)GetProcAddress(nHandle,"_oakBegin@0");
	if( oakBegin == NULL ) goto Failer;

	oakEnd=(poakEnd)GetProcAddress(nHandle,"_oakEnd@4");
	if( oakEnd == NULL ) goto Failer;

	oakExport = (poakExport)GetProcAddress(nHandle,"_oakExport@4");
	if( oakExport == NULL ) goto Failer;

	oakSetOption=(poakSetOption)GetProcAddress(nHandle,"_oakSetOption@24");
	if( oakSetOption == NULL ) goto Failer;

	oakGetOption=(poakGetOption)GetProcAddress(nHandle,"_oakGetOption@24");
	if( oakGetOption == NULL ) goto Failer;

	return TRUE;

Failer:
	FreeDLL(); 
	return FALSE;
}

/*------------------------------------------------------------------------------------------------------
 Free dynamic link library---pstopdf.dll
------------------------------------------------------------------------------------------------------*/
void FreeDLL()
{
	if( nHandle == NULL )
		return;

	FreeLibrary(nHandle);
	nHandle = NULL;	
}

/*******************************************************************************************************
 *  main() 
 *  function: This demo converts ps/eps file(s) to tiff files.
 *******************************************************************************************************/
int main()
{
	long id, iRet;
    char sOwnerPw[] = "1111";
	char sUserPw[]  = "2222";

	//Load dynamic link library---pstotiff.dll
	if( !LoadDLL() )
		exit(FALSE);


	//------------------------------------------------------------------------------------------------
	// Convert one ps/eps file to a general pdf file.
	//------------------------------------------------------------------------------------------------
    id = oakBegin();
	oakSetOption(id, OAK_Set_Input, 0, 0, "_test_01.ps", NULL);
    oakSetOption(id, OAK_Set_Input, 0, 0, "_test_02.eps", NULL);
	oakSetOption(id, OAK_Set_Output, 0, 0, "mytest_general.pdf", NULL);

    oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_TITLE, "untitled document");
    oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_AUTHOR, "bobol");
    oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_APPLICATION, "OakDoc PS to PDF sdk demo");

	iRet = oakExport(id);
	oakEnd(id);
	//------------------------------------------------------------------------------------------------


	//------------------------------------------------------------------------------------------------
	// Convert one ps/eps file to an restricted pdf file.
	//------------------------------------------------------------------------------------------------

	id = oakBegin();
	oakSetOption(id, OAK_Set_Input, 0, 0, "_test_01.ps", NULL);
    oakSetOption(id, OAK_Set_Input, 0, 0, "_test_02.eps", NULL);
	oakSetOption(id, OAK_Set_Output, 0, 0, "mytest_restricted.pdf", NULL);

    oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_TITLE, "untitled document");
    oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_AUTHOR, "bobol");
    oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_APPLICATION, "OakDoc PS to PDF sdk demo");

    oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_128, OAK_PDF_PERMISSION_PRINT+OAK_PDF_PERMISSION_COPYING, sUserPw, sOwnerPw);
    
	iRet = oakExport(id);
	oakEnd(id);
	//------------------------------------------------------------------------------------------------


	//Free dynamic link library---pstopdf.dll
	FreeDLL();
	exit(TRUE);
}
