Public Class Form1

    '1.1 SDK interface definitions.
    '==========================================================================================================================
    Private Declare Function oakBegin Lib "pstopdf.dll" Alias "_oakBegin@0" () As Integer
    Private Declare Sub oakEnd Lib "pstopdf.dll" Alias "_oakEnd@4" (ByVal id As Integer)
    Private Declare Function oakExport Lib "pstopdf.dll" Alias "_oakExport@4" (ByVal id As Integer) As Integer
    Private Declare Function oakSetOption Lib "pstopdf.dll" Alias "_oakSetOption@24" (ByVal id As Integer, ByVal code As Integer, ByVal nOptVal1 As Integer, ByVal nOptVal2 As Integer, ByVal sOptVal1 As String, ByVal sOptVal2 As String) As Integer
    Private Declare Function oakGetOption Lib "pstopdf.dll" Alias "_oakGetOption@24" (ByVal id As Integer, ByVal code As Integer, ByVal nOptVal1 As Integer, ByVal nOptVal2 As Integer, ByVal sOptVal1 As String, ByVal sOptVal2 As String) As Integer


    '1.2 Supported option definitions.
    '==========================================================================================================================
    Const OAK_Set_Input = 5301
    Const OAK_Set_Output = 5302
    Const OAK_Set_PDFInfo = 5307
    Const OAK_Set_PDFEncrypt = 5308


    '1.3 Supported pdf information
    '==========================================================================================================================
    Const OAK_PDF_TITLE = "title"
    Const OAK_PDF_SUBJECT = "subject"
    Const OAK_PDF_AUTHOR = "author"
    Const OAK_PDF_KEYWORDS = "keywords"
    Const OAK_PDF_APPLICATION = "creator"


    '1.4 Supported the length of pdf encrypt
    '==========================================================================================================================
    Const OAK_PDF_ENCRYPT_LEVEL_40 = 40
    Const OAK_PDF_ENCRYPT_LEVEL_128 = 128


    '1.5 Supported operation limited
    '==========================================================================================================================
    Const OAK_PDF_PERMISSION_NONE = 0
    Const OAK_PDF_PERMISSION_PRINT = 1
    Const OAK_PDF_PERMISSION_COPYING = 2
    Const OAK_PDF_PERMISSION_MODIFY = 4
    Const OAK_PDF_PERMISSION_ALL = 7



    '------------------------------------------------------------------------------------------------
    ' Convert one ps/eps file to a general pdf file.
    '------------------------------------------------------------------------------------------------
    Private Sub btnDemo1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDemo1.Click
        Dim id, iRet As Long

        id = oakBegin()
        If (id <> 0) Then
            oakSetOption(id, OAK_Set_Input, 0, 0, "_test_01.ps", 0)   'input file.
            oakSetOption(id, OAK_Set_Input, 0, 0, "_test_02.eps", 0)   'input file.
            oakSetOption(id, OAK_Set_Output, 0, 0, "mytest_general.pdf", 0)  'output pdf file.

            oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_TITLE, "untitled document")
            oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_AUTHOR, "bobol")
            oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_APPLICATION, "OakDoc PS to PDF sdk demo")

            iRet = oakExport(id)
            oakEnd(id)
        End If
    End Sub

    '------------------------------------------------------------------------------------------------
    ' Convert one ps/eps file to an restricted pdf file.
    '------------------------------------------------------------------------------------------------
    Private Sub btnDemo2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDemo2.Click
        Dim id, iRet As Long
        Dim sOwnerPw, sUserPw As String

        sOwnerPw = "1111"
        sUserPw = "2222"

        id = oakBegin()
        If (id <> 0) Then
            oakSetOption(id, OAK_Set_Input, 0, 0, "_test_01.ps", 0)   'input file.
            oakSetOption(id, OAK_Set_Input, 0, 0, "_test_02.eps", 0)   'input file.
            oakSetOption(id, OAK_Set_Output, 0, 0, "mytest_restricted.pdf", 0)  'output pdf file.

            oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_TITLE, "untitled document")
            oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_AUTHOR, "bobol")
            oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDF_APPLICATION, "OakDoc PS to PDF sdk demo")

            oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_128, OAK_PDF_PERMISSION_PRINT + OAK_PDF_PERMISSION_COPYING, sUserPw, sOwnerPw)

            iRet = oakExport(id)
            oakEnd(id)
        End If
    End Sub
End Class
